#line 1 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_Player_events_code.c"
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_player_objects.h"
typedef struct Screen TScreen;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef const struct CLabel {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCLabel;

typedef struct Image {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

typedef struct Box_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox_Round;

typedef struct Line {
 TScreen* OwnerScreen;
 char Order;
 unsigned int First_Point_X;
 unsigned int First_Point_Y;
 unsigned int Second_Point_X;
 unsigned int Second_Point_Y;
 char Pen_Width;
 char Visible;
 unsigned int Color;
} TLine;

typedef struct ProgressBar {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 unsigned int Background_Color;
 unsigned int Min;
 unsigned int Max;
 unsigned int Position;
 char Show_Position;
 char Show_Percentage;
 char Smooth;
 char Rounded;
 char Corner_Radius;
} TProgressBar;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CLabelsCount;
 TCLabel * const code *CLabels;
 unsigned int ImagesCount;
 TImage * const code *Images;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
 unsigned int Boxes_RoundCount;
 TBox_Round * const code *Boxes_Round;
 unsigned int LinesCount;
 TLine * const code *Lines;
 unsigned int ProgressBarsCount;
 TProgressBar * const code *ProgressBars;
};

extern TScreen Screen1;
extern TImage PauseButton;
extern TImage PlayButton;
extern TBox ProgressMasque;
extern TBox MasqueVolume;
extern TProgressBar ProgressBar1;
extern TLine VolumeLine;
extern TBox_Round VolumeButton;
extern TLabel TextVolume;
extern TBox_Round ProgressButton;
extern TImage StopButton;
extern TImage ForwardButton;
extern TImage BackButton;
extern TLine Line1;
extern TCLabel Label1;
extern TLabel * const code Screen1_Labels[1];
extern TCLabel * const code Screen1_CLabels[1];
extern TImage * const code Screen1_Images[5];
extern TBox * const code Screen1_Boxes[2];
extern TBox_Round * const code Screen1_Boxes_Round[2];
extern TLine * const code Screen1_Lines[2];
extern TProgressBar * const code Screen1_ProgressBars[1];




void ButtonRound1OnClick();
void MasqueVolumeOnPress();
void ProgressMasqueOnPress();
void StopButtonOnClick();
void VolumeButtonOnUp();




extern char PauseButton_Caption[];
extern char PlayButton_Caption[];
extern char ProgressMasque_Caption[];
extern char MasqueVolume_Caption[];
extern char ProgressBar1_Caption[];
extern char VolumeLine_Caption[];
extern char VolumeButton_Caption[];
extern char TextVolume_Caption[];
extern char ProgressButton_Caption[];
extern char StopButton_Caption[];
extern char ForwardButton_Caption[];
extern char BackButton_Caption[];
extern char Line1_Caption[];
extern const char Label1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCLabel(TCLabel *AClabel);
void DrawImage(TImage *AImage);
void DrawBox(TBox *ABox);
void DrawRoundBox(TBox_Round *Around_box);
void DrawLine(TLine *Aline);
void DrawProgressBar(TProgressBar *AProgressBar);
void UpdatePBPosition(TProgressBar *AProgressBar);
void Check_TP();
void Start_TP();
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_player_resources.h"
const code char Tahoma11x13_Regular[];
const code char pause_jpg[13193];
const code char play_jpg[13133];
const code char stop_jpg[12720];
const code char forward_jpg[13538];
const code char back_jpg[19759];
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
#line 31 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern unsigned long file_size;
extern char * mp3_buffer;
extern char volume_left, volume_right;

extern const char WRITE_CODE ;
extern const char READ_CODE ;

extern const char SCI_BASE_ADDR ;
extern const char SCI_MODE_ADDR ;
extern const char SCI_STATUS_ADDR ;
extern const char SCI_BASS_ADDR ;
extern const char SCI_CLOCKF_ADDR ;
extern const char SCI_DECODE_TIME_ADDR ;
extern const char SCI_AUDATA_ADDR ;
extern const char SCI_WRAM_ADDR ;
extern const char SCI_WRAMADDR_ADDR ;
extern const char SCI_HDAT0_ADDR ;
extern const char SCI_HDAT1_ADDR ;
extern const char SCI_AIADDR_ADDR ;
extern const char SCI_VOL_ADDR ;
extern const char SCI_AICTRL0_ADDR ;
extern const char SCI_AICTRL1_ADDR ;
extern const char SCI_AICTRL2_ADDR ;
extern const char SCI_AICTRL3_ADDR ;
#line 59 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern sbit Mmc_Chip_Select;
extern sbit Mmc_Chip_Select_Direction;
#line 65 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern sbit CS_Serial_Flash_bit;
extern sbit CS_Serial_Flash_Direction_bit;
#line 71 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern sbit MP3_CS_Direction;
extern sbit MP3_CS;
extern sbit MP3_RST_Direction;
extern sbit MP3_RST;
extern sbit DREQ_Direction;
extern sbit DREQ;
extern sbit BSYNC_Direction;
extern sbit BSYNC;

extern int playing;
extern unsigned long total_file_size;
extern unsigned long file_size;
extern int volume;
extern int volume_old;
extern char * nomFichier;
extern short fileHandler;
extern int FatType;
extern int first;

void MP3_Start(void);
void MP3_Init(void);
int StartPlayingFile(char * fileName);
void ContinuePlaying();
void ChangePosition(unsigned long position);


void MP3_SCI_Write(char address, unsigned int data_in);

void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer);

void MP3_SDI_Write(char data_);

void MP3_SDI_Write_32(char *data_);

void MP3_Set_Volume(char left, char right);
#line 13 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_Player_events_code.c"
void ButtonRound1OnClick() {
 if(playing == 0) {
 if (first == 1) {
 StartPlayingFile(&nomFichier);
 first = 0;
 }
 else ContinuePlaying();
 }
 else {
 playing = 0;
 }
 PauseButton.Active = playing;
 PauseButton.Visible = playing;
 PlayButton.Active = 1-playing;
 PlayButton.Visible = 1-playing;
 if(playing)DrawImage(&PauseButton);
 else DrawImage(&PlayButton);
}

void MasqueVolumeOnPress() {
 float vol;
 extern Ycoord;
 TextVolume.Font_Color = CL_WHITE;
 DrawLabel(&TextVolume);
 volume = Ycoord - VolumeLine.First_Point_Y;
 if (volume < 0) volume = 0;
 else if (volume > 100) volume = 100;
 volume = 100 - volume;
 sprintf(TextVolume.caption,"%d%%",volume);
 TextVolume.Font_Color = CL_BLACK;
 DrawLabel(&TextVolume);
 VolumeButton.Top = Ycoord - VolumeButton.Height/2;
 if (VolumeButton.Top < VolumeLine.First_Point_Y - VolumeButton.Height/2) VolumeButton.Top = VolumeLine.First_Point_Y - VolumeButton.Height/2;
 else if (VolumeButton.Top > VolumeLine.Second_Point_Y - VolumeButton.Height/2) VolumeButton.Top = VolumeLine.Second_Point_Y - VolumeButton.Height/2;
 DrawBox(&MasqueVolume);
 DrawLine(&VolumeLine);
 DrawRoundBox(&VolumeButton);
 if (volume < 1) volume = 1;
 if (volume != volume_old) {
 vol = (1-(log10(volume)/2.0)) * 255;
 MP3_Set_Volume(floor(vol), floor(vol));
 volume_old = volume;
 }
}

void VolumeButtonOnUp() {
 DrawLabel(&TextVolume);
}

void ProgressMasqueOnPress() {
 extern Xcoord;
 int position = 0;
 long int temp = 0;
 playing = 0;
 if (Xcoord < ProgressBar1.Left-ProgressButton.Width/2) position = ProgressBar1.Left-ProgressButton.Width/2;
 else if (Xcoord > ProgressBar1.Left+ProgressBar1.Width-ProgressButton.Width/2) position = ProgressBar1.Left+ProgressBar1.Width-ProgressButton.Width/2;
 else position = Xcoord - ProgressButton.Width/2;
 ProgressButton.Left = position;
 DrawBox(&ProgressMasque);
 DrawProgressBar(&ProgressBar1);
 DrawRoundBox(&ProgressButton);
 temp = position/(ProgressBar1.Left+ProgressBar1.Width-(ProgressButton.Width/2.))*total_file_size;

 ChangePosition(temp);
 file_size = total_file_size - temp;
 ContinuePlaying();
}

void StopButtonOnClick() {
 int position = 0;
 PauseButton.Active = 0;
 PauseButton.Visible = 0;
 PlayButton.Active = 1;
 PlayButton.Visible = 1;
 playing = 0;
 if (FatType == 16) {
 Mmc_Fat_Reset(&file_size);
#line 94 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_Player_events_code.c"
 }
 position = ProgressBar1.Left-ProgressButton.Width/2;
 ProgressBar1.position = 0;
 ProgressButton.Left = position;
 DrawBox(&ProgressMasque);
 DrawProgressBar(&ProgressBar1);
 DrawRoundBox(&ProgressButton);
 DrawImage(&PlayButton);
}
