/*
 * Project name:
     MP3_Player.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     28/02/2013
 * Time of creation
     14:27:36
 * Test configuration:
     MCU:             P32MX460F512L
     Dev.Board:       MikroMMB_for_PIC32_hw_rev_1.10
                      http://www.mikroe.com/mikromedia/pic32/
     Oscillator:      80000000 Hz
     SW:              mikroC PRO for PIC32
                      http://www.mikroe.com/mikroc/pic32/
 */

#include "MP3_Player_objects.h"
#include "MP3_driver.h"
#include "USBdsc.c"

#define USB_LEN                64
#define FILE_NAME_START_POS    39
#define FILENAME_LEN           12

#define IS_FILE_ATTR           2
#define IS_DIR_ATTR            3

char ReadBuffer[USB_LEN], WriteBuffer[USB_LEN];
char previous_file[FILENAME_LEN+1]="";
char current_file[FILENAME_LEN+1]="<first>";
char next_file[FILENAME_LEN+1]="";
char filename[FILENAME_LEN+1]="";
int ind_dir = 0;
int is_dir = 0, is_file = 0, cr_found = 0;

void ViderBuffer(char * buffer, int len)
{
  int i = 0;
  for (i=0; i<len;i++) *(buffer+i) = 0;
}

void USB_Isr() iv IVT_USB_1 ilevel 7 ics ICS_SRS {
    USB_Interrupt_Proc();
    USBIF_bit = 0;
}

void PrintChar(char ch) {
/*
  WriteBuffer[ind_dir] = ch;
  if (ind_dir == USB_LEN-1) {
     ind_dir = 0;
     HID_Write(WriteBuffer, USB_LEN);
     ViderBuffer(WriteBuffer, USB_LEN);
  }
  else ind_dir++;
*/

    if (ind_dir == 0) {
      is_dir = 0;
      is_file = 0;
      cr_found = 0;
      ViderBuffer(filename,FILENAME_LEN);
    }
    if (ch == '\r') {
       cr_found = 1;
    }
    if ((ind_dir == IS_FILE_ATTR)&&(ch != '-')) is_file = 1;
    if ((ind_dir == IS_DIR_ATTR)&&(ch != '-')) is_dir = 1;
    if ((ind_dir >= FILE_NAME_START_POS)&&(cr_found==0)) filename[ind_dir - FILE_NAME_START_POS] = ch;
    ind_dir++;
    if (ch=='\n'){
       ind_dir = 0;
       if ((is_dir==1)||(is_file==1)){
         sprintf(WriteBuffer, "%s\r\n", filename);
         HID_Write(WriteBuffer, USB_LEN);
       }
    }

}


void main() {
  int toogle = 0;
  
  file_size = 0;
  total_file_size =0;
  playing = 0;
  first = 1;
  toogle = 0;
  
  USBIP0_bit = 1;
  USBIP1_bit = 1;
  USBIP2_bit = 1;
  
  USBIE_bit = 1;
  ViderBuffer(WriteBuffer, USB_LEN);
  HID_Enable(ReadBuffer, WriteBuffer);

  Start_TP();
  
  MP3_Start();
  FatType = 0;
  while (FatType == 0)
  {
      if (Mmc_Fat_Init()==0) FatType=16; /*
      else if (FAT32_Init()==0) FatType=32;  */
      else FatType=0;
      
      if (toogle == 1){
        TFT_Set_Font(TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
        toogle = 0;
      }
      else {
        TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
        toogle = 1;
      }
      TFT_Write_Text("Mounting SD ...", 100, 100);
      Delay_ms(200);
  }
  TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
  TFT_Write_Text("Mounting SD ...", 100, 100);
  
  strcpy(&nomFichier,"SOUND.MP3");

  while (1) {
    ProgressMasque.Active = playing;
    Check_TP();
    if (HID_Read())
    {
       if (strstr(ReadBuffer, "dir")) {
           ViderBuffer(ReadBuffer, USB_LEN);
           ind_dir = 0;
           ViderBuffer(WriteBuffer, USB_LEN);
           Mmc_Fat_Dir(PrintChar);
           //HID_Write(WriteBuffer, USB_LEN);
       }
       if (strstr(ReadBuffer, "cd ")) {
           Mmc_Fat_ChangeDir(ReadBuffer+strlen("cd "));
           strcpy(WriteBuffer, "OK");
           HID_Write(WriteBuffer, USB_LEN);
           ViderBuffer(ReadBuffer, USB_LEN);
           ViderBuffer(WriteBuffer, USB_LEN);
       }
    }
  }

}