#line 1 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_Player_main.c"
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_player_objects.h"
typedef struct Screen TScreen;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef const struct CLabel {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCLabel;

typedef struct Image {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

typedef struct Box_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox_Round;

typedef struct Line {
 TScreen* OwnerScreen;
 char Order;
 unsigned int First_Point_X;
 unsigned int First_Point_Y;
 unsigned int Second_Point_X;
 unsigned int Second_Point_Y;
 char Pen_Width;
 char Visible;
 unsigned int Color;
} TLine;

typedef struct ProgressBar {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 unsigned int Background_Color;
 unsigned int Min;
 unsigned int Max;
 unsigned int Position;
 char Show_Position;
 char Show_Percentage;
 char Smooth;
 char Rounded;
 char Corner_Radius;
} TProgressBar;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CLabelsCount;
 TCLabel * const code *CLabels;
 unsigned int ImagesCount;
 TImage * const code *Images;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
 unsigned int Boxes_RoundCount;
 TBox_Round * const code *Boxes_Round;
 unsigned int LinesCount;
 TLine * const code *Lines;
 unsigned int ProgressBarsCount;
 TProgressBar * const code *ProgressBars;
};

extern TScreen Screen1;
extern TImage PauseButton;
extern TImage PlayButton;
extern TBox ProgressMasque;
extern TBox MasqueVolume;
extern TProgressBar ProgressBar1;
extern TLine VolumeLine;
extern TBox_Round VolumeButton;
extern TLabel TextVolume;
extern TBox_Round ProgressButton;
extern TImage StopButton;
extern TImage ForwardButton;
extern TImage BackButton;
extern TLine Line1;
extern TCLabel Label1;
extern TLabel * const code Screen1_Labels[1];
extern TCLabel * const code Screen1_CLabels[1];
extern TImage * const code Screen1_Images[5];
extern TBox * const code Screen1_Boxes[2];
extern TBox_Round * const code Screen1_Boxes_Round[2];
extern TLine * const code Screen1_Lines[2];
extern TProgressBar * const code Screen1_ProgressBars[1];




void ButtonRound1OnClick();
void MasqueVolumeOnPress();
void ProgressMasqueOnPress();
void StopButtonOnClick();
void VolumeButtonOnUp();




extern char PauseButton_Caption[];
extern char PlayButton_Caption[];
extern char ProgressMasque_Caption[];
extern char MasqueVolume_Caption[];
extern char ProgressBar1_Caption[];
extern char VolumeLine_Caption[];
extern char VolumeButton_Caption[];
extern char TextVolume_Caption[];
extern char ProgressButton_Caption[];
extern char StopButton_Caption[];
extern char ForwardButton_Caption[];
extern char BackButton_Caption[];
extern char Line1_Caption[];
extern const char Label1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCLabel(TCLabel *AClabel);
void DrawImage(TImage *AImage);
void DrawBox(TBox *ABox);
void DrawRoundBox(TBox_Round *Around_box);
void DrawLine(TLine *Aline);
void DrawProgressBar(TProgressBar *AProgressBar);
void UpdatePBPosition(TProgressBar *AProgressBar);
void Check_TP();
void Start_TP();
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
#line 31 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern unsigned long file_size;
extern char * mp3_buffer;
extern char volume_left, volume_right;

extern const char WRITE_CODE ;
extern const char READ_CODE ;

extern const char SCI_BASE_ADDR ;
extern const char SCI_MODE_ADDR ;
extern const char SCI_STATUS_ADDR ;
extern const char SCI_BASS_ADDR ;
extern const char SCI_CLOCKF_ADDR ;
extern const char SCI_DECODE_TIME_ADDR ;
extern const char SCI_AUDATA_ADDR ;
extern const char SCI_WRAM_ADDR ;
extern const char SCI_WRAMADDR_ADDR ;
extern const char SCI_HDAT0_ADDR ;
extern const char SCI_HDAT1_ADDR ;
extern const char SCI_AIADDR_ADDR ;
extern const char SCI_VOL_ADDR ;
extern const char SCI_AICTRL0_ADDR ;
extern const char SCI_AICTRL1_ADDR ;
extern const char SCI_AICTRL2_ADDR ;
extern const char SCI_AICTRL3_ADDR ;
#line 59 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern sbit Mmc_Chip_Select;
extern sbit Mmc_Chip_Select_Direction;
#line 65 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern sbit CS_Serial_Flash_bit;
extern sbit CS_Serial_Flash_Direction_bit;
#line 71 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern sbit MP3_CS_Direction;
extern sbit MP3_CS;
extern sbit MP3_RST_Direction;
extern sbit MP3_RST;
extern sbit DREQ_Direction;
extern sbit DREQ;
extern sbit BSYNC_Direction;
extern sbit BSYNC;

extern int playing;
extern unsigned long total_file_size;
extern unsigned long file_size;
extern int volume;
extern int volume_old;
extern char * nomFichier;
extern short fileHandler;
extern int FatType;
extern int first;

void MP3_Start(void);
void MP3_Init(void);
int StartPlayingFile(char * fileName);
void ContinuePlaying();
void ChangePosition(unsigned long position);


void MP3_SCI_Write(char address, unsigned int data_in);

void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer);

void MP3_SDI_Write(char data_);

void MP3_SDI_Write_32(char *data_);

void MP3_Set_Volume(char left, char right);
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/usbdsc.c"
const unsigned int USB_VENDOR_ID = 0x003F;
const unsigned int USB_PRODUCT_ID = 0x04D8;
const char USB_SELF_POWER = 0x80;
const char USB_MAX_POWER = 50;
const char HID_INPUT_REPORT_BYTES = 64;
const char HID_OUTPUT_REPORT_BYTES = 64;
const char USB_TRANSFER_TYPE = 0x03;
const char EP_IN_INTERVAL = 1;
const char EP_OUT_INTERVAL = 1;

const char USB_INTERRUPT = 1;
const char USB_HID_EP = 1;
const char USB_HID_RPT_SIZE = 33;


const struct {
 char bLength;
 char bDescriptorType;
 unsigned int bcdUSB;
 char bDeviceClass;
 char bDeviceSubClass;
 char bDeviceProtocol;
 char bMaxPacketSize0;
 unsigned int idVendor;
 unsigned int idProduct;
 unsigned int bcdDevice;
 char iManufacturer;
 char iProduct;
 char iSerialNumber;
 char bNumConfigurations;
} device_dsc = {
 0x12,
 0x01,
 0x0200,
 0x00,
 0x00,
 0x00,
 8,
 USB_VENDOR_ID,
 USB_PRODUCT_ID,
 0x0001,
 0x01,
 0x02,
 0x00,
 0x01
 };


const char configDescriptor1[]= {

 0x09,
 0x02,
 0x29,0x00,
 1,
 1,
 0,
 USB_SELF_POWER,
 USB_MAX_POWER,


 0x09,
 0x04,
 0,
 0,
 2,
 0x03,
 0,
 0,
 0,


 0x09,
 0x21,
 0x01,0x01,
 0x00,
 1,
 0x22,
 USB_HID_RPT_SIZE,0x00,


 0x07,
 0x05,
 USB_HID_EP | 0x80,
 USB_TRANSFER_TYPE,
 0x40,0x00,
 EP_IN_INTERVAL,


 0x07,
 0x05,
 USB_HID_EP,
 USB_TRANSFER_TYPE,
 0x40,0x00,
 EP_OUT_INTERVAL
};

const struct {
 char report[USB_HID_RPT_SIZE];
}hid_rpt_desc =
 {
 {0x06, 0x00, 0xFF,
 0x09, 0x01,
 0xA1, 0x01,

 0x19, 0x01,
 0x29, 0x40,
 0x15, 0x00,
 0x26, 0xFF, 0x00,
 0x75, 0x08,
 0x95, HID_INPUT_REPORT_BYTES,
 0x81, 0x02,

 0x19, 0x01,
 0x29, 0x40,
 0x75, 0x08,
 0x95, HID_OUTPUT_REPORT_BYTES,
 0x91, 0x02,
 0xC0}
 };


const struct {
 char bLength;
 char bDscType;
 unsigned int string[1];
 } strd1 = {
 4,
 0x03,
 {0x0409}
 };



const struct{
 char bLength;
 char bDscType;
 unsigned int string[10];
 }strd2={
 22,
 0x03,
 {'M','i','k','r','o','m','e','d','i','a'}
 };


const struct{
 char bLength;
 char bDscType;
 unsigned int string[10];
}strd3={
 22,
 0x03,
 {'M','P','3',' ','P','l','a','y','e','r'}
 };


const char* USB_config_dsc_ptr[1];


const char* USB_string_dsc_ptr[3];

void USB_Init_Desc(){
 USB_config_dsc_ptr[0] = &configDescriptor1;
 USB_string_dsc_ptr[0] = (const char*)&strd1;
 USB_string_dsc_ptr[1] = (const char*)&strd2;
 USB_string_dsc_ptr[2] = (const char*)&strd3;
}
#line 30 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_Player_main.c"
char ReadBuffer[ 64 ], WriteBuffer[ 64 ];
char previous_file[ 12 +1]="";
char current_file[ 12 +1]="<first>";
char next_file[ 12 +1]="";
char filename[ 12 +1]="";
int ind_dir = 0;
int is_dir = 0, is_file = 0, cr_found = 0;

void ViderBuffer(char * buffer, int len)
{
 int i = 0;
 for (i=0; i<len;i++) *(buffer+i) = 0;
}

void USB_Isr() iv IVT_USB_1 ilevel 7 ics ICS_SRS {
 USB_Interrupt_Proc();
 USBIF_bit = 0;
}

void PrintChar(char ch) {
#line 60 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_Player_main.c"
 if (ind_dir == 0) {
 is_dir = 0;
 is_file = 0;
 cr_found = 0;
 ViderBuffer(filename, 12 );
 }
 if (ch == '\r') {
 cr_found = 1;
 }
 if ((ind_dir ==  2 )&&(ch != '-')) is_file = 1;
 if ((ind_dir ==  3 )&&(ch != '-')) is_dir = 1;
 if ((ind_dir >=  39 )&&(cr_found==0)) filename[ind_dir -  39 ] = ch;
 ind_dir++;
 if (ch=='\n'){
 ind_dir = 0;
 if ((is_dir==1)||(is_file==1)){
 sprintf(WriteBuffer, "%s\r\n", filename);
 HID_Write(WriteBuffer,  64 );
 }
 }

}


void main() {
 int toogle = 0;

 file_size = 0;
 total_file_size =0;
 playing = 0;
 first = 1;
 toogle = 0;

 USBIP0_bit = 1;
 USBIP1_bit = 1;
 USBIP2_bit = 1;

 USBIE_bit = 1;
 ViderBuffer(WriteBuffer,  64 );
 HID_Enable(ReadBuffer, WriteBuffer);

 Start_TP();

 MP3_Start();
 FatType = 0;
 while (FatType == 0)
 {
#line 108 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_Player_main.c"
 if (Mmc_Fat_Init()==0) FatType=16;
 else FatType=0;

 if (toogle == 1){
 TFT_Set_Font(TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
 toogle = 0;
 }
 else {
 TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
 toogle = 1;
 }
 TFT_Write_Text("Mounting SD ...", 100, 100);
 Delay_ms(200);
 }
 TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
 TFT_Write_Text("Mounting SD ...", 100, 100);

 strcpy(&nomFichier,"SOUND.MP3");

 while (1) {
 ProgressMasque.Active = playing;
 Check_TP();
 if (HID_Read())
 {
 if (strstr(ReadBuffer, "dir")) {
 ViderBuffer(ReadBuffer,  64 );
 ind_dir = 0;
 ViderBuffer(WriteBuffer,  64 );
 Mmc_Fat_Dir(PrintChar);

 }
 if (strstr(ReadBuffer, "cd ")) {
 Mmc_Fat_ChangeDir(ReadBuffer+strlen("cd "));
 strcpy(WriteBuffer, "OK");
 HID_Write(WriteBuffer,  64 );
 ViderBuffer(ReadBuffer,  64 );
 ViderBuffer(WriteBuffer,  64 );
 }
 }
 }

}
