#line 1 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/built_in.h"
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
#line 31 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern unsigned long file_size;
extern char * mp3_buffer;
extern char volume_left, volume_right;

extern const char WRITE_CODE ;
extern const char READ_CODE ;

extern const char SCI_BASE_ADDR ;
extern const char SCI_MODE_ADDR ;
extern const char SCI_STATUS_ADDR ;
extern const char SCI_BASS_ADDR ;
extern const char SCI_CLOCKF_ADDR ;
extern const char SCI_DECODE_TIME_ADDR ;
extern const char SCI_AUDATA_ADDR ;
extern const char SCI_WRAM_ADDR ;
extern const char SCI_WRAMADDR_ADDR ;
extern const char SCI_HDAT0_ADDR ;
extern const char SCI_HDAT1_ADDR ;
extern const char SCI_AIADDR_ADDR ;
extern const char SCI_VOL_ADDR ;
extern const char SCI_AICTRL0_ADDR ;
extern const char SCI_AICTRL1_ADDR ;
extern const char SCI_AICTRL2_ADDR ;
extern const char SCI_AICTRL3_ADDR ;
#line 59 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern sbit Mmc_Chip_Select;
extern sbit Mmc_Chip_Select_Direction;
#line 65 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern sbit CS_Serial_Flash_bit;
extern sbit CS_Serial_Flash_Direction_bit;
#line 71 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_driver.h"
extern sbit MP3_CS_Direction;
extern sbit MP3_CS;
extern sbit MP3_RST_Direction;
extern sbit MP3_RST;
extern sbit DREQ_Direction;
extern sbit DREQ;
extern sbit BSYNC_Direction;
extern sbit BSYNC;

extern int playing;
extern unsigned long total_file_size;
extern unsigned long file_size;
extern int volume;
extern int volume_old;
extern char * nomFichier;
extern short fileHandler;
extern int FatType;
extern int first;

void MP3_Start(void);
void MP3_Init(void);
int StartPlayingFile(char * fileName);
void ContinuePlaying();
void ChangePosition(unsigned long position);


void MP3_SCI_Write(char address, unsigned int data_in);

void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer);

void MP3_SDI_Write(char data_);

void MP3_SDI_Write_32(char *data_);

void MP3_Set_Volume(char left, char right);
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_player_objects.h"
typedef struct Screen TScreen;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef const struct CLabel {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCLabel;

typedef struct Image {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

typedef struct Box_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox_Round;

typedef struct Line {
 TScreen* OwnerScreen;
 char Order;
 unsigned int First_Point_X;
 unsigned int First_Point_Y;
 unsigned int Second_Point_X;
 unsigned int Second_Point_Y;
 char Pen_Width;
 char Visible;
 unsigned int Color;
} TLine;

typedef struct ProgressBar {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 unsigned int Background_Color;
 unsigned int Min;
 unsigned int Max;
 unsigned int Position;
 char Show_Position;
 char Show_Percentage;
 char Smooth;
 char Rounded;
 char Corner_Radius;
} TProgressBar;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CLabelsCount;
 TCLabel * const code *CLabels;
 unsigned int ImagesCount;
 TImage * const code *Images;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
 unsigned int Boxes_RoundCount;
 TBox_Round * const code *Boxes_Round;
 unsigned int LinesCount;
 TLine * const code *Lines;
 unsigned int ProgressBarsCount;
 TProgressBar * const code *ProgressBars;
};

extern TScreen Screen1;
extern TImage PauseButton;
extern TImage PlayButton;
extern TBox ProgressMasque;
extern TBox MasqueVolume;
extern TProgressBar ProgressBar1;
extern TLine VolumeLine;
extern TBox_Round VolumeButton;
extern TLabel TextVolume;
extern TBox_Round ProgressButton;
extern TImage StopButton;
extern TImage ForwardButton;
extern TImage BackButton;
extern TLine Line1;
extern TCLabel Label1;
extern TLabel * const code Screen1_Labels[1];
extern TCLabel * const code Screen1_CLabels[1];
extern TImage * const code Screen1_Images[5];
extern TBox * const code Screen1_Boxes[2];
extern TBox_Round * const code Screen1_Boxes_Round[2];
extern TLine * const code Screen1_Lines[2];
extern TProgressBar * const code Screen1_ProgressBars[1];




void ButtonRound1OnClick();
void MasqueVolumeOnPress();
void ProgressMasqueOnPress();
void StopButtonOnClick();
void VolumeButtonOnUp();




extern char PauseButton_Caption[];
extern char PlayButton_Caption[];
extern char ProgressMasque_Caption[];
extern char MasqueVolume_Caption[];
extern char ProgressBar1_Caption[];
extern char VolumeLine_Caption[];
extern char VolumeButton_Caption[];
extern char TextVolume_Caption[];
extern char ProgressButton_Caption[];
extern char StopButton_Caption[];
extern char ForwardButton_Caption[];
extern char BackButton_Caption[];
extern char Line1_Caption[];
extern const char Label1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCLabel(TCLabel *AClabel);
void DrawImage(TImage *AImage);
void DrawBox(TBox *ABox);
void DrawRoundBox(TBox_Round *Around_box);
void DrawLine(TLine *Aline);
void DrawProgressBar(TProgressBar *AProgressBar);
void UpdatePBPosition(TProgressBar *AProgressBar);
void Check_TP();
void Start_TP();
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/mp3_player_resources.h"
const code char Tahoma11x13_Regular[];
const code char pause_jpg[13193];
const code char play_jpg[13133];
const code char stop_jpg[12720];
const code char forward_jpg[13538];
const code char back_jpg[19759];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/built_in.h"
#line 34 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
unsigned long file_size;
unsigned long total_file_size;
const BYTES_2_WRITE = 32;
char mp3_buffer[BYTES_2_WRITE];
char volume_left, volume_right;
int volume = 50;
int volume_old = 50;
int FatType = 0;


const char WRITE_CODE = 0x02;
const char READ_CODE = 0x03;

const char SCI_BASE_ADDR = 0x00;
const char SCI_MODE_ADDR = 0x00;
const char SCI_STATUS_ADDR = 0x01;
const char SCI_BASS_ADDR = 0x02;
const char SCI_CLOCKF_ADDR = 0x03;
const char SCI_DECODE_TIME_ADDR = 0x04;
const char SCI_AUDATA_ADDR = 0x05;
const char SCI_WRAM_ADDR = 0x06;
const char SCI_WRAMADDR_ADDR = 0x07;
const char SCI_HDAT0_ADDR = 0x08;
const char SCI_HDAT1_ADDR = 0x09;
const char SCI_AIADDR_ADDR = 0x0A;
const char SCI_VOL_ADDR = 0x0B;
const char SCI_AICTRL0_ADDR = 0x0C;
const char SCI_AICTRL1_ADDR = 0x0D;
const char SCI_AICTRL2_ADDR = 0x0E;
const char SCI_AICTRL3_ADDR = 0x0F;
#line 68 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
sbit Mmc_Chip_Select at LATG9_bit;
sbit Mmc_Chip_Select_Direction at TRISG9_bit;
#line 74 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
sbit CS_Serial_Flash_bit at LATC2_bit;
sbit CS_Serial_Flash_Direction_bit at TRISC2_bit;
#line 80 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
sbit MP3_CS_Direction at TRISG15_bit;
sbit MP3_CS at LATG15_bit;
sbit MP3_RST_Direction at TRISD9_bit;
sbit MP3_RST at LATD9_bit;
sbit DREQ_Direction at TRISD8_bit;
sbit DREQ at RD8_bit;
sbit BSYNC_Direction at TRISB8_bit;
sbit BSYNC at LATB8_bit;

int playing = 0;

int first = 1;

char nomFichier[25] = "";
short fileHandler = 0;
#line 104 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
void MP3_SCI_Write(char address, unsigned int data_in) {
 BSYNC = 1;

 MP3_CS = 0;
 SPI2_Write(WRITE_CODE);
 SPI2_Write(address);
 SPI2_Write( ((char *)&data_in)[1] );
 SPI2_Write( ((char *)&data_in)[0] );
 MP3_CS = 1;
 while (DREQ == 0);
}
#line 123 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer) {
 unsigned int temp;

 MP3_CS = 0;
 SPI2_Write(READ_CODE);
 SPI2_Write(start_address);

 while (words_count--) {
 temp = SPI2_Read(0);
 temp <<= 8;
 temp += SPI2_Read(0);
 *(data_buffer++) = temp;
 }
 MP3_CS = 1;
 while (DREQ == 0);
}
#line 147 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
void MP3_SDI_Write(char data_) {

 MP3_CS = 1;
 BSYNC = 0;

 while (DREQ == 0);

 SPI2_Write(data_);
 BSYNC = 1;
}
#line 165 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
void MP3_SDI_Write_32(char *data_) {
 char i;

 MP3_CS = 1;
 BSYNC = 0;

 while (DREQ == 0);

 for (i=0; i<32; i++)
 SPI2_Write(data_[i]);
 BSYNC = 1;
}
#line 185 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
void MP3_Set_Volume(char left, char right) {
 unsigned int volume;

 volume = (left<<8) + right;
 MP3_SCI_Write(SCI_VOL_ADDR, volume);
}

void MP3_Init(void)
{
 BSYNC = 1;
 MP3_CS = 1;


 MP3_RST = 0;
 Delay_ms(10);
 MP3_RST = 1;

 while (DREQ == 0);

 MP3_SCI_Write(SCI_MODE_ADDR, 0x0800);
 MP3_SCI_Write(SCI_BASS_ADDR, 0x7A00);
 MP3_SCI_Write(SCI_CLOCKF_ADDR, 0x2000);


 volume_left = 0x42;
 volume_right = 0x42;
 MP3_Set_Volume(volume_left, volume_right);

 MP3_CS = 0;
}
#line 223 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
void MP3_Start(void)
{
 IC1CONbits.FEDGE = 1;
 IC1IP0_bit = 1;
 IC1IP1_bit = 1;
 IC1IP2_bit = 1;
 IC1CONSETbits.ICI = 0b00;
 IC1CONSETbits.ICM = 0b001;
 IC1CONbits.ON = 1;
 IC1CONbits.SIDL = 0;
 IC1IE_bit = 1;
 EnableInterrupts();

 CS_Serial_Flash_Direction_bit = 0;
 CS_Serial_Flash_bit = 1;

 MP3_CS_Direction = 0;
 MP3_CS = 1;
 MP3_RST_Direction = 0;
 MP3_RST = 1;

 DREQ_Direction = 1;
 BSYNC_Direction = 0;
 BSYNC = 0;
 BSYNC = 1;

 SPI2_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, 26, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_IDLE_2_ACTIVE);

 MP3_Init();
 Delay_ms(1000);
}

int StartPlayingFile(char * fileName)
{
 int i = 0;
 int position = 0;
 int result = 0;
 if (FatType == 16) {
 result = Mmc_Fat_Assign(fileName, 0x01);
#line 266 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
 }

 if (result == 1) {
 Mmc_Fat_Reset(&file_size);
 total_file_size = file_size;
 playing = 1;
 while (DREQ == 1) {
 for (i=0; i<BYTES_2_WRITE; i++)
 {
#line 276 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
 if(FatType == 16) Mmc_Fat_Read(mp3_buffer+i);
 }
 file_size-=BYTES_2_WRITE;
 MP3_SDI_Write_32(mp3_buffer);
 }
 position = (total_file_size - file_size) * 100 / total_file_size;
 if (ProgressBar1.position != position) {
 ProgressBar1.position = position;
 ProgressButton.Left = ProgressBar1.Left + ProgressBar1.position/100.0 * ProgressBar1.Width - ProgressButton.Width/2;
 DrawBox(&ProgressMasque);
 DrawProgressBar(&ProgressBar1);
 DrawRoundBox(&ProgressButton);
 }
 return 0;
 }
 else return -1;
}

void ContinuePlaying() {
 int i = 0;
 int position = 0;
 playing = 0;
 while(DREQ == 0);
 while ((DREQ == 1) && (file_size >= BYTES_2_WRITE)) {
 for (i=0; i<BYTES_2_WRITE; i++)
 {
#line 303 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
 if(FatType == 16) Mmc_Fat_Read(mp3_buffer+i);
 }
 file_size-=BYTES_2_WRITE;
 MP3_SDI_Write_32(mp3_buffer);
 }
 playing = 1;
 position = (total_file_size - file_size) * 100 / total_file_size;
 if (ProgressBar1.position != position) {
 ProgressBar1.position = position;
 ProgressButton.Left = ProgressBar1.Left + ProgressBar1.position/100.0 * ProgressBar1.Width - ProgressButton.Width/2;
 DrawBox(&ProgressMasque);
 DrawProgressBar(&ProgressBar1);
 DrawRoundBox(&ProgressButton);
 }
}

void ChangePosition(unsigned long position)
{
#line 322 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
 if(FatType == 16) Mmc_Fat_Seek(position);
}

void IC1_ISR() iv IVT_INPUT_CAPTURE_1 ilevel 7 ics ICS_SRS {
 long buff = 0;
 int i = 0;
 int position = 0;
 if (playing == 1) {
 while ((DREQ == 1) && (file_size >= BYTES_2_WRITE)) {
 for (i=0; i<BYTES_2_WRITE; i++)
 {
#line 334 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
 if(FatType == 16) Mmc_Fat_Read(mp3_buffer+i);
 }
 file_size-=BYTES_2_WRITE;
 MP3_SDI_Write_32(mp3_buffer);
 }
 if (file_size < BYTES_2_WRITE) {
 for (i=0; i<file_size; i++)
 {
#line 343 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/MP3_driver.c"
 if(FatType == 16) Mmc_Fat_Read(mp3_buffer+i);
 }
 for (i=0; i<file_size; i++)
 {
 MP3_SDI_Write(mp3_buffer+i);
 }
 playing = 0;
 }
 position = (total_file_size - file_size) * 100 / total_file_size;
 if (ProgressBar1.position != position) {
 ProgressBar1.position = position;
 ProgressButton.Left = ProgressBar1.Left + ProgressBar1.position/100.0 * ProgressBar1.Width - ProgressButton.Width/2;
 DrawBox(&ProgressMasque);
 DrawProgressBar(&ProgressBar1);
 DrawRoundBox(&ProgressButton);
 }
 }
 buff = IC1BUF;
 IC1IF_bit = 0;
}
