#line 1 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/__Lib_FAT32_Driver.c"
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/__lib_fat32.h"
#line 29 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/__lib_fat32.h"
typedef unsigned short uint8;
typedef signed short int8;
typedef unsigned int uint16;
typedef signed int int16;
typedef unsigned long uint32;
typedef signed long int32;
typedef unsigned long long uint64;
typedef signed long long int64;

static const uint16 SECTOR_SIZE = 512;









static const uint8
 FILE_READ = 0x01,
 FILE_WRITE = 0x02,
 FILE_APPEND = 0x04;






static const uint8
 ATTR_NONE = 0x00,
 ATTR_READ_ONLY = 0x01,
 ATTR_HIDDEN = 0x02,
 ATTR_SYSTEM = 0x04,
 ATTR_VOLUME_ID = 0x08,
 ATTR_DIRECTORY = 0x10,
 ATTR_ARCHIVE = 0x20,
 ATTR_DEVICE = 0x40,

 ATTR_RESERVED = 0x80;

static const uint8
 ATTR_LONG_NAME = ATTR_READ_ONLY |
 ATTR_HIDDEN |
 ATTR_SYSTEM |
 ATTR_VOLUME_ID;

static const uint8
 ATTR_FILE_MASK = ATTR_READ_ONLY |
 ATTR_HIDDEN |
 ATTR_SYSTEM |
 ATTR_ARCHIVE,

 ATTR_LONG_NAME_MASK = ATTR_READ_ONLY |
 ATTR_HIDDEN |
 ATTR_SYSTEM |
 ATTR_VOLUME_ID |
 ATTR_DIRECTORY |
 ATTR_ARCHIVE;






static const int8



 OK = 0,
 ERROR = -1,
 FOUND = 1,



 E_READ = -1,
 E_WRITE = -2,
 E_INIT_CARD = -3,
 E_BOOT_SIGN = -4,
 E_BOOT_REC = -5,
 E_FILE_SYS_INFO = -6,
 E_DEVICE_SIZE = -7,
 E_FAT_TYPE = -8,



 E_LAST_ENTRY = -10,
 E_FREE_ENTRY = -11,
 E_CLUST_NUM = -12,
 E_NO_SWAP_SPACE = -13,
 E_NO_SPACE = -14,



 E_DIR_NAME = -20,
 E_ISNT_DIR = -21,
 E_DIR_EXISTS = -22,
 E_DIR_NOTFOUND = -23,
 E_DIR_NOTEMPTY = -24,



 E_FILE_NAME = -30,
 E_ISNT_FILE = -31,
 E_FILE_EXISTS = -32,
 E_FILE_NOTFOUND = -33,
 E_FILE_NOTEMPTY = -34,
 E_MAX_FILES = -35,
 E_FILE_NOTOPENED = -36,
 E_FILE_EOF = -37,
 E_FILE_READ = -38,
 E_FILE_WRITE = -39,
 E_FILE_HANDLE = -40,
 E_FILE_READ_ONLY = -41,
 E_FILE_OPENED = -42,



 E_TIME_YEAR = -50,
 E_TIME_MONTH = -51,
 E_TIME_DAY = -52,
 E_TIME_HOUR = -53,
 E_TIME_MINUTE = -54,
 E_TIME_SECOND = -55;



typedef struct
{
 uint8 State[1];
 uint8 __1[3];
 uint8 Type[1];
 uint8 __2[3];
 uint8 Boot[4];
 uint8 Size[4];
}
FAT32_PART;



typedef struct
{
 uint8 __1[446];
 FAT32_PART Part[4];
 uint8 BootSign[2];
}
FAT32_MBR;



typedef struct
{
 uint8 JmpCode[3];
 uint8 __1[8];
 uint8 BytesPSect[2];
 uint8 SectsPClust[1];
 uint8 Reserved[2];
 uint8 FATCopies[1];
 uint8 __2[4];
 uint8 MediaDesc[1];
 uint8 __3[10];
 uint8 Sects[4];
 uint8 SectsPFAT[4];
 uint8 Flags[2];
 uint8 __4[2];
 uint8 RootClust[4];
 uint8 FSISect[2];
 uint8 BootBackup[2];
 uint8 __5[14];
 uint8 ExtSign[1];
 uint8 __6[4];
 uint8 VolName[11];
 uint8 FATName[8];
 uint8 __7[420];
 uint8 BootSign[2];
}
FAT32_BR;



typedef struct
{
 uint8 LeadSig[4];
 uint8 __1[480];
 uint8 StrucSig[4];
 uint8 FreeCount[4];
 uint8 NextFree[4];
 uint8 __2[14];
 uint8 TrailSig[2];
}
FAT32_FSI;


typedef struct
{
 uint8 Entry[4];
}
FAT32_FATENT;



typedef struct
{
 uint8 NameExt[11];
 uint8 Attrib[1];
 uint8 __1[2];
 uint8 CTime[2];
 uint8 CDate[2];
 uint8 ATime[2];
 uint8 HiClust[2];
 uint8 MTime[2];
 uint8 MDate[2];
 uint8 LoClust[2];
 uint8 Size[4];
}
FAT32_DIRENT;



typedef uint32 __CLUSTER;
typedef uint32 __SECTOR;
typedef uint32 __ENTRY;

typedef int8 __HANDLE;



typedef struct
{
 uint16 Year;
 uint8 Month;
 uint8 Day;
 uint8 Hour;
 uint8 Minute;
 uint8 Second;
}
__TIME;



typedef struct
{
 uint8 State;
 uint8 Type;
 __SECTOR Boot;
 uint32 Size;
}
__PART;



typedef struct
{
 __PART Part[1];
 uint16 BytesPSect;
 uint8 SectsPClust;
 uint16 Reserved;
 uint8 FATCopies;
 uint32 SectsPFAT;
 uint16 Flags;
 __SECTOR FAT;
 __CLUSTER Root;
 __SECTOR Data;
 __SECTOR FSI;
 uint32 ClFreeCount;
 __CLUSTER ClNextFree;
}
__INFO;


typedef struct
{
 char NameExt[13];
 uint8 Attrib;

 uint32 Size;
 __CLUSTER _1stClust;

 __CLUSTER EntryClust;
 __ENTRY Entry;
}
__DIR;


typedef struct
{
 __CLUSTER _1stClust;
 __CLUSTER CurrClust;

 __CLUSTER EntryClust;
 __ENTRY Entry;

 uint32 Cursor;
 uint32 Length;

 uint8 Mode;
 uint8 Attr;
}
__FILE;
#line 332 "c:/users/laurent amaury/dropbox/microcontroleurs/visual tft projects/mp3/mp3_player_code/mikroc pro for pic32/__lib_fat32.h"
typedef struct
{
 __SECTOR fSectNum;
 char fSect[SECTOR_SIZE];
}
__RAW_SECTOR;


extern const char CRLF_F32[];
extern const uint8 FAT32_MAX_FILES;
extern const uint8 f32_fsi_template[SECTOR_SIZE];
extern const uint8 f32_br_template[SECTOR_SIZE];
extern __FILE fat32_fdesc[];
extern __RAW_SECTOR f32_sector;


extern int8 FAT32_Dev_Init (void);
extern int8 FAT32_Dev_Read_Sector (__SECTOR sc, char* buf);
extern int8 FAT32_Dev_Write_Sector (__SECTOR sc, char* buf);
extern int8 FAT32_Dev_Multi_Read_Stop();
extern int8 FAT32_Dev_Multi_Read_Sector(char* buf);
extern int8 FAT32_Dev_Multi_Read_Start(__SECTOR sc);
extern int8 FAT32_Put_Char (char ch);


int8 FAT32_Init (void);
int8 FAT32_Format (char *devLabel);
int8 FAT32_ScanDisk (uint32 *totClust, uint32 *freeClust, uint32 *badClust);
int8 FAT32_GetFreeSpace(uint32 *freeClusts, uint16 *bytesPerClust);

int8 FAT32_ChangeDir (char *dname);
int8 FAT32_MakeDir (char *dname);
int8 FAT32_Dir (void);
int8 FAT32_FindFirst (__DIR *pDE);
int8 FAT32_FindNext (__DIR *pDE);
int8 FAT32_Delete (char *fn);
int8 FAT32_DeleteRec (char *fn);
int8 FAT32_Exists (char *name);
int8 FAT32_Rename (char *oldName, char *newName);
int8 FAT32_Open (char *fn, uint8 mode);
int8 FAT32_Eof (__HANDLE fHandle);
int8 FAT32_Read (__HANDLE fHandle, char* rdBuf, uint16 len);
int8 FAT32_Write (__HANDLE fHandle, char* wrBuf, uint16 len);
int8 FAT32_Seek (__HANDLE fHandle, uint32 pos);
int8 FAT32_Tell (__HANDLE fHandle, uint32 *pPos);
int8 FAT32_Close (__HANDLE fHandle);
int8 FAT32_Size (char *fname, uint32 *pSize);
int8 FAT32_GetFileHandle(char *fname, __HANDLE *handle);

int8 FAT32_SetTime (__TIME *pTM);
int8 FAT32_IncTime (uint32 Sec);

int8 FAT32_GetCTime (char *fname, __TIME *pTM);
int8 FAT32_GetMTime (char *fname, __TIME *pTM);

int8 FAT32_SetAttr (char *fname, uint8 attr);
int8 FAT32_GetAttr (char *fname, uint8* attr);

int8 FAT32_GetError (void);

int8 FAT32_MakeSwap (char *name, __SECTOR nSc, __CLUSTER *pCl);
#line 25 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/__Lib_FAT32_Driver.c"
int8 FAT32_Dev_Init(void)
{
 if (OK != Mmc_Init())
 {
 return ERROR;
 }
 return OK;
}
#line 44 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/__Lib_FAT32_Driver.c"
int8 FAT32_Dev_Read_Sector(__SECTOR sc, char* buf)
{
 if (Mmc_Read_Sector(sc, buf) != OK)
 {
 return ERROR;
 }
 return OK;
}
#line 63 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/__Lib_FAT32_Driver.c"
int8 FAT32_Dev_Write_Sector(__SECTOR sc, char* buf)
{
 if (Mmc_Write_Sector(sc, buf) != OK)
 {
 return ERROR;
 }
 return OK;
}
#line 84 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/__Lib_FAT32_Driver.c"
int8 FAT32_Dev_SectorCount(uint32 *scCnt)
{
 uint8 csdbuf[16];
 uint16 c_size, c_size_mult, mult,
 read_bl_len, block_len;
 uint32 size, blocknr;


 if (Mmc_Read_Csd(csdbuf) != OK)
 {
 return ERROR;
 }


 if (1 == ((csdbuf[0] & 0xC0) >> 6))
 {
 size = 0; size <<= 8;
 size += csdbuf[7] & 0x3F; size <<= 8;
 size += csdbuf[8]; size <<= 8;
 size += csdbuf[9]; size <<= 0;


 size *= 1024;
 }

 else
 {
 c_size = ((csdbuf[8] & 0xC0) >> 6) +
 ((unsigned) csdbuf[7] << 2) +
 (((unsigned) csdbuf[6] & 0x03) << 10);
 c_size_mult = (csdbuf[10] & 0x80) +
 (((unsigned) csdbuf[9] & 0x03) << 8);
 c_size_mult = c_size_mult >> 7;

 read_bl_len = csdbuf[5] & 0x0f;

 mult = 1;
 mult = mult << (c_size_mult + 2);

 blocknr = (c_size + 1) * (long) mult;
 block_len = 1;
 block_len = block_len << read_bl_len;

 size = block_len * blocknr;


 size /= 512;
 }

 *scCnt = size;

 return OK;
}
#line 166 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/__Lib_FAT32_Driver.c"
int8 FAT32_Dev_Multi_Read_Start(__SECTOR sc)
{
 if (Mmc_Multi_Read_Start(sc) != OK)
 {
 return ERROR;
 }
 return OK;
}
#line 185 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/__Lib_FAT32_Driver.c"
int8 FAT32_Dev_Multi_Read_Stop()
{
 if (Mmc_Multi_Read_Stop() != OK)
 {
 return ERROR;
 }
 return OK;
}
#line 205 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/__Lib_FAT32_Driver.c"
int8 FAT32_Dev_Multi_Read_Sector(char* buf)
{
 Mmc_Multi_Read_Sector(buf);
 return OK;
}
#line 276 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Visual TFT Projects/MP3/MP3_Player_Code/mikroC PRO for PIC32/__Lib_FAT32_Driver.c"
int8 FAT32_Put_Char(char ch)
{
 UART_Write(ch);
 return OK;
}









int8 FAT32_Get_Char(char *ch)
{
 if (1 == UART_Data_Ready())
 {
 *ch = UART_Read();
 return OK;
 }
 return ERROR;
}
